from ajenti.api import *
from ajenti.plugins import *


info = PluginInfo(
    title='User Hierarchy',
    icon='group',
    dependencies=[
        PluginDependency('configurator'),
        PluginDependency('main'),
    ],
)


def init():
    import api
    import main

    from ajenti.plugins.configurator.configurator import Configurator

    old_init = Configurator.init

    def new_init(self, *args):
        old_init(self, *args)
        self.hmgr = api.UserHierarchyManager.get()

        old_bind = self.find('users').post_item_bind

        def post_user_bind(object, collection, item, ui):
            ui.find('organization').value = self.hmgr.get_organization(item.name)
            old_bind(object, collection, item, ui)

        self.find('users').post_item_bind = post_user_bind

        old_update = self.find('users').post_item_update

        def post_user_update(object, collection, item, ui):
            self.hmgr.set_organization(item.name, ui.find('organization').value)
            old_update(object, collection, item, ui)

        self.find('users').post_item_update = post_user_update

        self.find('users').find_type('formgroup').append(
            self.ui.create('formline', text='Organization', children=[
                self.ui.create('textbox', id='organization')
            ])
        )

    Configurator.init = new_init
