from ajenti.api import *
from ajenti.ui import *


@plugin
class UserHierarchyManager (BasePlugin):
    default_classconfig = {
        'parents': {},
    }
    classconfig_root = True

    def init(self):
        self.classconfig.setdefault('organizations', {})

    def get_parent(self, user):
        return self.classconfig['parents'].get(user, None)

    def set_parent(self, user, parent):
        self.classconfig['parents'][user] = parent
        self.save_classconfig()

    def get_organization(self, user):
        return self.classconfig['organizations'].get(user, None)

    def set_organization(self, user, organization):
        self.classconfig['organizations'][user] = organization
        self.save_classconfig()
